/* GadMGet.h */

#ifndef MGET_H
#define MGET_H

#define NUL 					0

#define USE_CUSTOMSCREEN 	0
#define USE_PUBSCREEN 		1
#define USE_WBSCREEN		2

#include <stdio.h>
#include <string.h>
#include <dos/dos.h>
#include <exec/types.h>
#include <intuition/intuition.h>
#include <intuition/intuitionbase.h>
#include <intuition/screens.h>
#include <graphics/gfxbase.h>
#include <libraries/gadtools.h>
#include <libraries/dos.h>			/* contains RETURN_OK, RETURN_WARN #def's */
#include <exec/lists.h>
#include <exec/nodes.h>
#include <exec/memory.h>
#include <exec/types.h>
#include <workbench/startup.h>
#include <workbench/workbench.h>

#include <intuition/gadgetclass.h>
#include <libraries/asl.h>
#include <clib/asl_protos.h>
#include <clib/alib_protos.h>
#include <clib/exec_protos.h>
#include <clib/dos_protos.h>
#include <clib/intuition_protos.h>
#include <clib/gadtools_protos.h>
#include <clib/alib_protos.h>
#include <clib/icon_protos.h>
#include <clib/wb_protos.h>

#include "mget_listview2.h"
#include "tree.h"

VOID debug(int a);
void EOLParse(char *sString);
VOID FindReturns(char *mystring);		
VOID main (int argc, char *argv[]);
VOID CleanUp(void);
VOID FreeFileNodes(struct List *);
VOID UpdateByteCount(char *mystring, int addorsub);
VOID UpperCase(char *oldstring);
VOID LowerCase(char *oldstring);
VOID SetMenuValues();
VOID findgadgoto(int index, int flashes);
VOID PrintList(struct List *);
VOID TurnOnAllMenuItems(struct Menu *);
VOID ParseCliArgs(int argc, char *argv[]);
VOID ParseWBArgs(struct WBStartup *argv);
VOID SetReqDefaults(char *szFilePath);
VOID PrintCommandString(int *printnextreturn, int *printed_bytes);
VOID GenerateCDCommand(int *printreturnfirst, int *printed_bytes, char *szLastDir, char *nodename);
VOID SortList(struct List *thislist, int nThisSortType);
VOID BubbleSortList(struct List *thislist, int nThisSortType, char *sWinString, char *sSortTypeString);
VOID TreeSortList(struct List *thislist, int nThisSortType, char *sWinString, char *sSortTypeString);
VOID SmartAdd(struct List *thislist, struct Node *addme, int nThisSortType);
VOID TreeSortList(struct List *thislist, int nThisSortType, char *sSortWinString, char *sSortTypeString);
VOID TransferToSelected(struct Node *current);
VOID TransferToFiles(struct Node *current);

LONG ListViewTop (struct Gadget *gad, struct Window *win);
struct Node * TailOf(struct List *thislist, int *index);

int AminetFileAge(char *sString);
int LengthOfWord(char *szString);
int ReScanAminetLine(char *dataline);
int isAminetParsable(char *dataline);
int PrintFile(char *szFileName, int PrintReturnFirst);
int AddFile(struct List *, char *);
int ReadmyFile(void);
int listviewgadgetClicked (VOID);
int AreAminetNames(char *s1, char *s2);
int AminetFileSize(char *sString);
int SearchList(char *key, int nSearchType);
int OutputList(struct List *thislist);
int RawOutputList(struct List *thislist);
void ChangeWindowTitle(void);
int RequestAFile(char *szBuffer);
int MakeReq(char *sText, char *sTitle, char *sGadgets);
int CompareByDir(struct Node *past, struct Node *current);
int CompareByDesc(struct Node *past, struct Node *current);
int CompareBySize(struct Node *past, struct Node *current);
int CompareByName(struct Node *past, struct Node *current);
int DeleteNodeError(struct Node *);
int PrintNodeData(struct Node *);
int TransferNode(struct Node *);
int DoNothing(struct Node *);

struct Node * ListViewTopNode(struct Gadget *, struct List *);

BOOL handle_window_events(struct Window *);


#endif

